﻿// $Header: $
// Copyright (c) CODE Consulting and Development, s.r.o., Plzen. All rights reserved.

// ReSharper disable ArrangeModifiersOrder
// ReSharper disable InconsistentNaming

using System;
using System.Diagnostics;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.OperationModel;

namespace BrowseServersWeb
{
    public partial class _Default : System.Web.UI.Page
    {
        // Use a shared client instance to allow for better optimization.
        static private readonly EasyDAClient Client = new EasyDAClient();

        protected void Page_Load(object sender, EventArgs e)
        {
            try
            {
                ServerElementCollection serverElements = Client.BrowseServers("");
                Debug.Assert(!(serverElements.Keys is null));

                // ReSharper disable once LoopCanBePartlyConvertedToQuery
                foreach (ServerElement serverElement in serverElements)
                {
                    Debug.Assert(!(serverElement is null));
                    ListBox1.Items.Add(serverElement.ServerClass);
                }
                ListBox1.Visible = true;
            }
            catch (OpcException ex)
            {
                TextBox1.Text = ex.GetBaseException().Message;
                TextBox1.Visible = true;
            }
        }

        protected override void OnInit(EventArgs e)
        {
            base.OnInit(e);
            Load += Page_Load;
        }
    }
}